/*
 * ExactSubtreeMatch.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ExactSubtreeMatch.h"
#include <registration/AlgoRegistration.hpp>

namespace arbology {

namespace exact {

auto ExactSubtreeMatchUnrankedTree = registration::AbstractRegister < ExactSubtreeMatch, ext::set < unsigned >, const tree::UnrankedTree < > &, const tree::UnrankedTree < > & > ( ExactSubtreeMatch::match );
auto ExactSubtreeMatchRankedTree = registration::AbstractRegister < ExactSubtreeMatch, ext::set < unsigned >, const tree::RankedTree < > &, const tree::RankedTree < > & > ( ExactSubtreeMatch::match );
auto ExactSubtreeMatchPrefixRankedTree = registration::AbstractRegister < ExactSubtreeMatch, ext::set < unsigned >, const tree::PrefixRankedTree < > &, const tree::PrefixRankedTree < > & > ( ExactSubtreeMatch::match );
auto ExactSubtreeMatchPrefixRankedBarTree = registration::AbstractRegister < ExactSubtreeMatch, ext::set < unsigned >, const tree::PrefixRankedBarTree < > &, const tree::PrefixRankedBarTree < > & > ( ExactSubtreeMatch::match );

} /* namespace exact */

} /* namespace arbology */
