/*
 * Trim.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATON_TRIM_H_
#define AUTOMATON_TRIM_H_

#include "UselessStatesRemover.h"
#include "UnreachableStatesRemover.h"

namespace automaton {

namespace simplify {

class Trim {
public:
	/**
	 * Removes dead states from FSM. Melichar 2.29
	 */
	template<class T>
	static T trim( const T & fsm );
};

template<class T>
T Trim::trim( const T & fsm ) {
	return UnreachableStatesRemover::remove(UselessStatesRemover::remove(fsm));
}

} /* namespace simplify */

} /* namespace automaton */

#endif /* AUTOMATON_TRIM_H_ */
