/*
 * ToRegExp.h
 *
 *  Created on: 4. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef GRAMMAR_TO_REG_EXP_H_
#define GRAMMAR_TO_REG_EXP_H_

#include <grammar/Regular/RightRG.h>
#include <grammar/Regular/LeftRG.h>

#include "ToRegExpAlgebraic.h"

namespace grammar {

namespace convert {

class ToRegExp {
public:
	/**
	 * @return regexp equivalent to source right regular grammar.
	 * @param grammar Grammar to convert
	 */
	template < class SymbolType >
	static regexp::UnboundedRegExp < > convert(const grammar::RightRG < SymbolType > & grammar);
	template < class SymbolType >
	static regexp::UnboundedRegExp < > convert(const grammar::LeftRG < SymbolType > & grammar);
};

template < class SymbolType >
regexp::UnboundedRegExp < > ToRegExp::convert(const grammar::RightRG < SymbolType > & grammar) {
	return ToRegExpAlgebraic::convert(grammar);
}

template < class SymbolType >
regexp::UnboundedRegExp < > ToRegExp::convert(const grammar::LeftRG < SymbolType > & grammar) {
	return ToRegExpAlgebraic::convert(grammar);
}

} /* namespace covert */

} /* namespace grammar */

#endif /* GRAMMAR_TO_REG_EXP_H_ */
