#include "HammingBitParalelismTest.h"

#include <string/LinearString.h>
#include <stringology/simulations/HammingBitParalelism.h>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( HammingBitParalelismTest, "bit paralelism" );
CPPUNIT_TEST_SUITE_REGISTRATION ( HammingBitParalelismTest );

void HammingBitParalelismTest::testSimple() {
  auto text = string::LinearString<>("adcabcaabadbbca");
  auto pattern = string::LinearString<>("adbbca");

  ext::set<unsigned int> expected_result = {1,9};
  auto result = stringology::simulations::HammingBitParalelism::search(text, pattern, 3);
  CPPUNIT_ASSERT(expected_result == result);
}

void HammingBitParalelismTest::setUp() { }

void HammingBitParalelismTest::tearDown() { }
