#ifndef LR_PARSER_TEST_H_
#define LR_PARSER_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class LRParser : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( LRParser );
	CPPUNIT_TEST ( testEndOfInputSymbol );
	CPPUNIT_TEST ( testParseCorrectInput );
	CPPUNIT_TEST ( testParseIncorrectInput );
	CPPUNIT_TEST_SUITE_END ( );

	DefaultSymbolType E = DefaultSymbolType ( 'E' );
	DefaultSymbolType T = DefaultSymbolType ( 'T' );
	DefaultSymbolType F = DefaultSymbolType ( 'F' );

	DefaultSymbolType plus = DefaultSymbolType ( '+' );
	DefaultSymbolType times = DefaultSymbolType ( '*' );
	DefaultSymbolType leftParenthesis = DefaultSymbolType ( '(' );
	DefaultSymbolType rightParenthesis = DefaultSymbolType ( ')' );
	DefaultSymbolType identifier = DefaultSymbolType ( "id" );

	grammar::CFG < > getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testEndOfInputSymbol ( );
	void testParseCorrectInput ( );
	void testParseIncorrectInput ( );
};

#endif /* LR_PARSER_TEST_H_ */
