/*
 * Bool.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "Bool.h"
#include <registration/ValuePrinterRegistration.hpp>

namespace primitive {

Bool::Bool(bool data) : m_data(data) {
}

PrimitiveBase* Bool::clone ( ) const & {
	return new Bool(*this);
}

PrimitiveBase* Bool::clone() && {
	return new Bool(std::move(*this));
}

bool Bool::getData() const {
	return m_data;
}

Bool::operator bool ( ) const {
	return m_data;
}

void Bool::setData(bool data) {
	this->m_data = data;
}

int Bool::compare(const Bool& other) const {
	return m_data - other.m_data;
}

void Bool::operator>>(std::ostream& out) const {
	out << "(Bool " << (m_data ? "true" : "false") << ")";
}

Bool::operator std::string() const {
	return m_data ? "true" : "false";
}

PrimitiveBase * Bool::inc() && {
	m_data = !m_data;
	return NULL;
}

} /* namespace primitive */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < primitive::Bool > ( );

} /* namespace */
