/*
 * BlankSymbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "BlankSymbol.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

BlankSymbol::BlankSymbol() {

}

SymbolBase* BlankSymbol::clone ( ) const & {
	return new BlankSymbol(*this);
}

SymbolBase* BlankSymbol::clone() && {
	return new BlankSymbol(std::move(*this));
}

int BlankSymbol::compare(const BlankSymbol&) const {
	return 0;
}

void BlankSymbol::operator>>(std::ostream& out) const {
	out << "(Blank symbol)";
}

BlankSymbol::operator std::string () const {
	return BlankSymbol::instance < std::string > ( );
}

object::ObjectBase * BlankSymbol::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::BlankSymbol > ( );

} /* namespace */
