/*
 * InitialSymbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "InitialSymbol.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

InitialSymbol::InitialSymbol() {

}

SymbolBase* InitialSymbol::clone ( ) const & {
	return new InitialSymbol(*this);
}

SymbolBase* InitialSymbol::clone() && {
	return new InitialSymbol(std::move(*this));
}

int InitialSymbol::compare(const InitialSymbol&) const {
	return 0;
}

void InitialSymbol::operator>>(std::ostream& out) const {
	out << "(InitialSymbol)";
}

InitialSymbol::operator std::string() const {
	return InitialSymbol::instance < std::string > ( );
}

object::ObjectBase * InitialSymbol::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::InitialSymbol > ( );

} /* namespace */
