/*
 * WildcardSymbol.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "WildcardSymbol.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace alphabet {

WildcardSymbol::WildcardSymbol() {

}

SymbolBase* WildcardSymbol::clone() const & {
	return new WildcardSymbol(*this);
}

SymbolBase* WildcardSymbol::clone() && {
	return new WildcardSymbol(std::move(*this));
}

int WildcardSymbol::compare(const WildcardSymbol&) const {
	return 0;
}

void WildcardSymbol::operator>>(std::ostream& out) const {
	out << "(WildcardSymbol)";
}

WildcardSymbol::operator std::string () const {
	return WildcardSymbol::instance < std::string > ( );
}

object::ObjectBase * WildcardSymbol::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}


} /* namespace alphabet */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < alphabet::WildcardSymbol > ( );

} /* namespace */
