/*
 * WildcardSymbol.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "WildcardSymbol.h"
#include <alphabet/Symbol.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

alphabet::WildcardSymbol xmlApi < alphabet::WildcardSymbol >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return alphabet::WildcardSymbol ( );
}

bool xmlApi < alphabet::WildcardSymbol >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < alphabet::WildcardSymbol >::xmlTagName ( ) {
	static std::string xmlTagName = "WildcardSymbol";

	return xmlTagName;
}

void xmlApi < alphabet::WildcardSymbol >::compose ( ext::deque < sax::Token > & output, const alphabet::WildcardSymbol & ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < alphabet::WildcardSymbol > ( );
static auto xmlRead = registration::XmlReaderRegister < alphabet::WildcardSymbol > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < alphabet::Symbol, alphabet::WildcardSymbol > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, alphabet::WildcardSymbol > ( );

} /* namespace */
