/*
 * FinalStateLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "FinalStateLabel.h"

#include <object/Object.h>
#include <object/UniqueObject.h>

#include <registration/ValuePrinterRegistration.hpp>

namespace label {

FinalStateLabel::FinalStateLabel() {
}

LabelBase* FinalStateLabel::clone ( ) const & {
	return new FinalStateLabel(*this);
}

LabelBase* FinalStateLabel::clone() && {
	return new FinalStateLabel(std::move(*this));
}

int FinalStateLabel::compare(const FinalStateLabel&) const {
	return 0;
}

void FinalStateLabel::operator>>(std::ostream& out) const {
	out << "(FinalStateLabel)";
}

FinalStateLabel::operator std::string() const {
	return FinalStateLabel::instance < std::string > ( );
}

object::ObjectBase * FinalStateLabel::inc ( ) && {
	return new object::UniqueObject ( object::Object ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace label */

namespace {

static auto valuePrinter = registration::ValuePrinterRegister < label::FinalStateLabel > ( );

} /* namespace */
