/*
 * TreeBase.h
 *
 * This file is part of Algorithms library toolkit.
 * Copyright (C) 2017 Jan Travnicek (jan.travnicek@fit.cvut.cz)

 * Algorithms library toolkit is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Algorithms library toolkit is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Algorithms library toolkit.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef TREE_BASE_H_
#define TREE_BASE_H_

#include <object/ObjectBase.h>

namespace tree {

/**
 * \brief Represents base for a concrete tree type.
 */
class TreeBase : public object::ObjectBase {
public:
	/**
	 * @copydoc ObjectBase::clone ( ) const &
	 */
	virtual TreeBase * clone ( ) const & override = 0;

	/**
	 * @copydoc ObjectBase::clone ( ) &&
	 */
	virtual TreeBase * clone ( ) && override = 0;
};

} /* namespace tree */

#endif /* TREE_BASE_H_ */
