#include "PtrArrayTest.h"
#include <alib/ptr_array>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( PtrArrayTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( PtrArrayTest );

void PtrArrayTest::setUp() {
}

void PtrArrayTest::tearDown() {
}

void PtrArrayTest::testProperties() {
	ext::ptr_array < int, 4 > data = {1, 2, 3, 4};

	std::cout << data [ 0 ] << std::endl;

	CPPUNIT_ASSERT ( data [ 0 ] == 1 );
	CPPUNIT_ASSERT ( data.size ( ) == 4 );
	CPPUNIT_ASSERT ( data [ 3 ] == 4 );
}

void PtrArrayTest::testPolymorph() {
	ext::ptr_array < Base, 4 > data = ext::make_ptr_array < Base > ( Child1 ( ), Child1 ( ), Child2 ( ), Child2 ( ) );

	CPPUNIT_ASSERT ( data.size ( ) == 4 );

	CPPUNIT_ASSERT ( data [ 0 ].type ( ) == PtrArrayTest::Type::CHILD1 );
	CPPUNIT_ASSERT ( data [ 1 ].type ( ) == PtrArrayTest::Type::CHILD1 );
	CPPUNIT_ASSERT ( data [ 2 ].type ( ) == PtrArrayTest::Type::CHILD2 );
	CPPUNIT_ASSERT ( data [ 3 ].type ( ) == PtrArrayTest::Type::CHILD2 );

	ext::ptr_array < Base, 4 >::const_iterator iter = data.cbegin ( );
	CPPUNIT_ASSERT ( iter->type ( ) == PtrArrayTest::Type::CHILD1 );
	++ iter;
	CPPUNIT_ASSERT ( iter->type ( ) == PtrArrayTest::Type::CHILD1 );
	++ iter;
	CPPUNIT_ASSERT ( iter->type ( ) == PtrArrayTest::Type::CHILD2 );
	++ iter;
	CPPUNIT_ASSERT ( iter->type ( ) == PtrArrayTest::Type::CHILD2 );
	++ iter;
	CPPUNIT_ASSERT ( iter == data.cend ( ) );
}
