/*
 * UniqueObject.cpp
 *
 *  Created on: Nov 11, 2016
 *      Author: Jan Travicek
 */

#include "UniqueObject.h"
#include <primitive/xml/Integer.h>

#include <registration/XmlRegistration.hpp>

namespace core {

object::UniqueObject xmlApi < object::UniqueObject >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );

	object::Object firstSymbol = core::xmlApi < object::Object >::parse ( input );
	primitive::Integer secondSymbol = core::xmlApi < primitive::Integer >::parse ( input );

	object::UniqueObject data ( std::move ( firstSymbol ), std::move ( secondSymbol ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < object::UniqueObject >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < object::UniqueObject >::xmlTagName ( ) {
	static std::string xmlTagName = "UniqueObject";

	return xmlTagName;
}

void xmlApi < object::UniqueObject >::compose ( ext::deque < sax::Token > & output, const object::UniqueObject & object ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	core::xmlApi < object::Object >::compose ( output, object.getObject ( ) );
	core::xmlApi < primitive::Integer >::compose ( output, object.getId ( ) );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < object::UniqueObject > ( );
static auto xmlRead = registration::XmlReaderRegister < object::UniqueObject > ( );

static auto xmlGroup = registration::XmlRegisterTypeInGroup < object::Object, object::UniqueObject > ( );

} /* namespace */
