/*
 * UnsignedLong.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#include "UnsignedLong.h"
#include <primitive/Primitive.h>
#include <object/Object.h>

#include <registration/XmlRegistration.hpp>

namespace core {

unsigned long xmlApi < unsigned long >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
	unsigned long data = ext::from_string < unsigned long > ( sax::FromXMLParserHelper::popTokenData ( input, sax::Token::TokenType::CHARACTER ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );
	return data;
}

bool xmlApi < unsigned long >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < unsigned long >::xmlTagName ( ) {
	static std::string xmlTagName = "UnsignedLong";

	return xmlTagName;
}

void xmlApi < unsigned long >::compose ( ext::deque < sax::Token > & output, unsigned long data ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT );
	output.emplace_back ( ext::to_string ( data ), sax::Token::TokenType::CHARACTER );
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT );
}

primitive::UnsignedLong xmlApi < primitive::UnsignedLong >::parse ( ext::deque < sax::Token >::iterator & input ) {
	return primitive::UnsignedLong ( xmlApi < unsigned long >::parse ( input ) );
}

bool xmlApi < primitive::UnsignedLong >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

const std::string & xmlApi < primitive::UnsignedLong >::xmlTagName ( ) {
	return xmlApi < unsigned long >::xmlTagName ( );
}

void xmlApi < primitive::UnsignedLong >::compose ( ext::deque < sax::Token > & output, const primitive::UnsignedLong & data ) {
	xmlApi < unsigned long >::compose ( output, data.getData ( ) );
}

} /* namespace core */

namespace {

static auto xmlWrite = registration::XmlWriterRegister < primitive::UnsignedLong > ( );
static auto xmlRead = registration::XmlReaderRegister < primitive::UnsignedLong > ( );

static auto xmlGroup1 = registration::XmlRegisterTypeInGroup < primitive::Primitive, primitive::UnsignedLong > ( );
static auto xmlGroup2 = registration::XmlRegisterTypeInGroup < object::Object, primitive::UnsignedLong > ( );

} /* namespace */
